/*
  The following sometimes fails with Cistream(streambuf* sb)

  std::stringstream ss;
  ss << "begin foo bar end" << std::ends;
  Cistream cs(ss.rdbuf());
  

  fix it by stating:  ss << "begin foo bar end\n" << std::ends;
  
 */


#include <iostream>          // C++ headers
#include <fstream>
#include <cstring>
#include <sstream>
#include <sys/types.h>

#include "Cistream.h"          // Application headers
#include "Error.h"

static Cistream CommentedInputStream(std::cin.rdbuf());
Cistream& ccin=CommentedInputStream;

Cistream::Cistream(streambuf* sb) : std::istream(sb),_cbuf(new CommentBuf(sb))
{
  rdbuf(_cbuf);
#ifndef USE_ISO_COMPLIANT_STD
  if (sb->_flags&_IO_NO_READS) setstate(ios_base::badbit);
#else
  if (sb->in_avail() <0) setstate(ios_base::failbit);
  //setstate(sb->state());
#endif


}
