/*****************************************************************************
 *
 *  LayoutBuilder.h                             XMM Science Analysis Subsystem
 *
 *  Abstract interface LayoutBuilder
 *
 *  (c) 1998  ESA  -  Written by Jon Brumfitt, Aurora
 *                 -  Exported by Jorgo Bakker, BSC to layout package
 *
 *  $Id: LayoutBuilder.h,v 1.1 2002/05/06 15:01:29 gvacanti Exp $
 *
 *****************************************************************************/

#ifndef LAYOUTBUILDER_H
#define LAYOUTBUILDER_H

class Layout;

//================================================================
//  Abstract interface LayoutBuilder
//
//  Interface for pluggable layout builders
//================================================================

class LayoutBuilder
{
public:
    virtual ~LayoutBuilder() {}
    virtual void buildSimple(Layout*) = 0;
    virtual void buildFrame(Layout*) = 0;
    virtual void buildCards(Layout*) = 0;
    virtual void buildRow(Layout*) = 0;
    virtual void buildColumn(Layout*) = 0;
    virtual void buildEnable(Layout*) = 0;
    virtual void buildChoice(Layout*) = 0;
};

#endif
